import type { MongoDBOIDCLogEventsMap, OIDCCallbackContext, IdPServerInfo, IdPServerResponse, TypedEventEmitter } from './types';
import { TokenSet } from 'openid-client';
import type { MongoDBOIDCPlugin, MongoDBOIDCPluginOptions } from './api';
/** @internal Exported for testing only */
export declare function automaticRefreshTimeoutMS(tokenSet: Pick<TokenSet, 'refresh_token' | 'expires_in'>): number | undefined;
/** @internal */
export declare class MongoDBOIDCPluginImpl implements MongoDBOIDCPlugin {
    private readonly options;
    readonly logger: TypedEventEmitter<MongoDBOIDCLogEventsMap>;
    private readonly mapIdpToAuthState;
    readonly mongoClientOptions: MongoDBOIDCPlugin['mongoClientOptions'];
    private readonly timers;
    constructor(options: Readonly<MongoDBOIDCPluginOptions>);
    private _deserialize;
    private _serialize;
    serialize(): Promise<string>;
    private isFlowAllowed;
    private getAuthState;
    private getRedirectURI;
    private getOIDCClient;
    private openBrowser;
    private notifyDeviceFlow;
    private updateStateWithTokenSet;
    private verifyValidUrl;
    private authorizationCodeFlow;
    private deviceAuthorizationFlow;
    private initiateAuthAttempt;
    requestToken(serverMetadata: IdPServerInfo, context: OIDCCallbackContext): Promise<IdPServerResponse>;
}
//# sourceMappingURL=plugin.d.ts.map